CodeForces - 203B

One not particularly beautiful evening Valera got very bored. To amuse himself a little bit, he found the following game.

He took a checkered white square piece of paper, consisting of n × n cells. After that, he started to paint the white cells black one after the other. In total he painted m different cells on the piece of paper. Since Valera was keen on everything square, he wondered, how many moves (i.e. times the boy paints a square black) he should make till a black square with side 3 can be found on the piece of paper. But Valera does not know the answer to this question, so he asks you to help him.

Your task is to find the minimum number of moves, till the checkered piece of paper has at least one black square with side of 3. Otherwise determine that such move does not exist.

Input

The first line contains two integers n and m (1 ≤ n ≤ 1000, 1 ≤ m ≤ min(n·n, 105))— the size of the squared piece of paper and the number of moves, correspondingly.

Then, m lines contain the description of the moves. The i-th line contains two integers xiyi (1 ≤ xi, yi ≤ n) — the number of row and column of the square that gets painted on the i-th move.

All numbers on the lines are separated by single spaces. It is guaranteed that all moves are different. The moves are numbered starting from 1 in the order, in which they are given in the input. The columns of the squared piece of paper are numbered starting from 1, from the left to the right. The rows of the squared piece of paper are numbered starting from 1, from top to bottom.

Output

On a single line print the answer to the problem — the minimum number of the move after which the piece of paper has a black square with side 3. If no such move exists, print -1.

Examples

Input

4 11
1 1
1 2
1 3
2 2
2 3
1 4
2 4
3 4
3 2
3 3
4 1

Output

10

Input

4 12
1 1
1 2
1 3
2 2
2 3
1 4
2 4
3 4
3 2
4 2
4 1
3 1

Output

-1

题意:

给一个n和m,代表有n*n的方格,m行输入给的格子,问到第几行时会出现3*3的方格都被走过;

先把每一步的路都存起来,再暴力找哪个是3*3的,并找出这个3*3中最大的是第几步;

#include <iostream>
#include <string.h>
#include<stdio.h>
#include<algorithm>
#include<math.h>
using namespace std;
int maze[1005][1005];
int ji[1005][1005];
bool re(int i,int j)//判断
{
    if(maze[i][j]==1)
        if(maze[i-1][j]==1)
            if(maze[i+1][j]==1)
                if(maze[i][j-1]==1)
                    if(maze[i][j+1]==1)
                        if(maze[i-1][j-1]==1)
                            if(maze[i-1][j+1]==1)
                                if(maze[i+1][j-1]==1)
                                    if(maze[i+1][j+1]==1)
                                        return true;
    return false;
}
int main()
{
    int n,m;
    while(~scanf("%d %d",&n,&m))
    {
        memset(maze,0,sizeof(maze));
        memset(ji,0,sizeof(ji));
        int flag=0;
        for(int i=0; i<m; i++)
        {
            int a,b;
            scanf("%d %d",&a,&b);
            ji[a][b]=i+1;
            maze[a][b]=1;
        }
        int ans=1000005,nnn;
        for(int i=1; i<=n; i++)
        {
            for(int j=1; j<=n; j++)
            {
                if(re(i,j))
                {
                    flag=1;
                    nnn=ji[i][j];
//                    if(ji[i][j]>nnn)nnn=ji[i][j];
                    if(ji[i-1][j]>nnn)nnn=ji[i-1][j];
                    if(ji[i+1][j]>nnn)nnn=ji[i+1][j];
                    if(ji[i][j-1]>nnn)nnn=ji[i][j-1];
                    if(ji[i][j+1]>nnn)nnn=ji[i][j+1];
                    if(ji[i-1][j-1]>nnn)nnn=ji[i-1][j-1];
                    if(ji[i-1][j+1]>nnn)nnn=ji[i-1][j+1];
                    if(ji[i+1][j-1]>nnn)nnn=ji[i+1][j-1];
                    if(ji[i+1][j+1]>nnn)nnn=ji[i+1][j+1];
                    if(nnn<ans)
                        ans=nnn;
                }
            }
        }
        if(flag)
            printf("%d\n",ans);
        else
            printf("-1\n");
    }
    return 0;

}


 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值